package com.tmax.openframe.variable;

import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.variable.group.*;
import java.math.*;
import java.text.DecimalFormat;
import java.util.*;
import java.util.function.BiFunction;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public class OIVPBROS_VariableContainer {
    public @Getter String WS_TRANS_ID = "OIBR";
    public @Getter String WS_MAPSET_NAME = "OIVPM02";
    public @Getter String WS_MAP_NAME = "OIVPM02";
    public @Getter @Setter int WS_RESPONSE_CODE;
    public @Getter @Setter int WS_RESPONSE_CODE2;
    public @Getter String WS_COMMUNICATION_AREA = StringUtils.repeat(' ', 1);
    public @Getter @Setter int WS_FIRST_TIME_FLAG;
    public @Getter @Setter OIVPBROS_WS_ERROR_MESSAGE WS_ERROR_MESSAGE = new OIVPBROS_WS_ERROR_MESSAGE();
    public @Getter @Setter OIVPBROS_OIVPM02I OIVPM02I = new OIVPBROS_OIVPM02I();

    public OIVPBROS_OIVPM02O getOIVPM02O() {
        return OIVPBROS_OIVPM02O.builder().FILLER28(getFILLER28())
                .FILLER29(getFILLER29()).DATEO(getDATEO())
                .FILLER30(getFILLER30()).TERMO(getTERMO())
                .FILLER31(getFILLER31()).TIMEO(getTIMEO())
                .FILLER32(getFILLER32()).IDEN1O(getIDEN1O())
                .FILLER33(getFILLER33()).NAME1O(getNAME1O())
                .FILLER34(getFILLER34()).DEPT1O(getDEPT1O())
                .FILLER35(getFILLER35()).PHON1O(getPHON1O())
                .FILLER36(getFILLER36()).IDEN2O(getIDEN2O())
                .FILLER37(getFILLER37()).NAME2O(getNAME2O())
                .FILLER38(getFILLER38()).DEPT2O(getDEPT2O())
                .FILLER39(getFILLER39()).PHON2O(getPHON2O())
                .FILLER40(getFILLER40()).IDEN3O(getIDEN3O())
                .FILLER41(getFILLER41()).NAME3O(getNAME3O())
                .FILLER42(getFILLER42()).DEPT3O(getDEPT3O())
                .FILLER43(getFILLER43()).PHON3O(getPHON3O())
                .FILLER44(getFILLER44()).IDEN4O(getIDEN4O())
                .FILLER45(getFILLER45()).NAME4O(getNAME4O())
                .FILLER46(getFILLER46()).DEPT4O(getDEPT4O())
                .FILLER47(getFILLER47()).PHON4O(getPHON4O())
                .FILLER48(getFILLER48()).IDEN5O(getIDEN5O())
                .FILLER49(getFILLER49()).NAME5O(getNAME5O())
                .FILLER50(getFILLER50()).DEPT5O(getDEPT5O())
                .FILLER51(getFILLER51()).PHON5O(getPHON5O())
                .FILLER52(getFILLER52()).BIDXO(getBIDXO())
                .FILLER53(getFILLER53()).FIDXO(getFIDXO())
                .FILLER54(getFILLER54()).MSGO(getMSGO()).build();
    }

    public void setOIVPM02O(String source) {
        setFILLER28(source.substring(0, 12));
        setFILLER29(source.substring(12, 15));
        setDATEO(source.substring(15, 23));
        setFILLER30(source.substring(23, 26));
        setTERMO(source.substring(26, 30));
        setFILLER31(source.substring(30, 33));
        setTIMEO(source.substring(33, 41));
        setFILLER32(source.substring(41, 44));
        setIDEN1O(source.substring(44, 52));
        setFILLER33(source.substring(52, 55));
        setNAME1O(source.substring(55, 65));
        setFILLER34(source.substring(65, 68));
        setDEPT1O(source.substring(68, 83));
        setFILLER35(source.substring(83, 86));
        setPHON1O(source.substring(86, 101));
        setFILLER36(source.substring(101, 104));
        setIDEN2O(source.substring(104, 112));
        setFILLER37(source.substring(112, 115));
        setNAME2O(source.substring(115, 125));
        setFILLER38(source.substring(125, 128));
        setDEPT2O(source.substring(128, 143));
        setFILLER39(source.substring(143, 146));
        setPHON2O(source.substring(146, 161));
        setFILLER40(source.substring(161, 164));
        setIDEN3O(source.substring(164, 172));
        setFILLER41(source.substring(172, 175));
        setNAME3O(source.substring(175, 185));
        setFILLER42(source.substring(185, 188));
        setDEPT3O(source.substring(188, 203));
        setFILLER43(source.substring(203, 206));
        setPHON3O(source.substring(206, 221));
        setFILLER44(source.substring(221, 224));
        setIDEN4O(source.substring(224, 232));
        setFILLER45(source.substring(232, 235));
        setNAME4O(source.substring(235, 245));
        setFILLER46(source.substring(245, 248));
        setDEPT4O(source.substring(248, 263));
        setFILLER47(source.substring(263, 266));
        setPHON4O(source.substring(266, 281));
        setFILLER48(source.substring(281, 284));
        setIDEN5O(source.substring(284, 292));
        setFILLER49(source.substring(292, 295));
        setNAME5O(source.substring(295, 305));
        setFILLER50(source.substring(305, 308));
        setDEPT5O(source.substring(308, 323));
        setFILLER51(source.substring(323, 326));
        setPHON5O(source.substring(326, 341));
        setFILLER52(source.substring(341, 344));
        setBIDXO(source.substring(344, 352));
        setFILLER53(source.substring(352, 355));
        setFIDXO(source.substring(355, 363));
        setFILLER54(source.substring(363, 366));
        setMSGO(source.substring(366, 442));
    }

    public void setOIVPM02O(OIVPBROS_OIVPM02O source) {
        setOIVPM02O(source.toString());
    }

    public String getFILLER28() {
        return getOIVPM02I().getFILLER1();
    }

    public void setFILLER28(String source) {
        OIVPM02I.setFILLER1(source);
    }

    public String getFILLER29() {
        return String.valueOf(getOIVPM02I().getDATEL())
                + getOIVPM02I().getDATEF();
    }

    public void setFILLER29(String source) {
        OIVPM02I.setDATEL(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setDATEF(source.substring(2));
    }

    public String getDATEO() {
        return getOIVPM02I().getDATEI();
    }

    public void setDATEO(String source) {
        OIVPM02I.setDATEI(source);
    }

    public String getFILLER30() {
        return String.valueOf(getOIVPM02I().getTERML())
                + getOIVPM02I().getTERMF();
    }

    public void setFILLER30(String source) {
        OIVPM02I.setTERML(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setTERMF(source.substring(2));
    }

    public String getTERMO() {
        return getOIVPM02I().getTERMI();
    }

    public void setTERMO(String source) {
        OIVPM02I.setTERMI(source);
    }

    public String getFILLER31() {
        return String.valueOf(getOIVPM02I().getTIMEL())
                + getOIVPM02I().getTIMEF();
    }

    public void setFILLER31(String source) {
        OIVPM02I.setTIMEL(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setTIMEF(source.substring(2));
    }

    public String getTIMEO() {
        return getOIVPM02I().getTIMEI();
    }

    public void setTIMEO(String source) {
        OIVPM02I.setTIMEI(source);
    }

    public String getFILLER32() {
        return String.valueOf(getOIVPM02I().getIDEN1L())
                + getOIVPM02I().getIDEN1F();
    }

    public void setFILLER32(String source) {
        OIVPM02I.setIDEN1L(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setIDEN1F(source.substring(2));
    }

    public String getIDEN1O() {
        return getOIVPM02I().getIDEN1I();
    }

    public void setIDEN1O(String source) {
        OIVPM02I.setIDEN1I(source);
    }

    public String getFILLER33() {
        return String.valueOf(getOIVPM02I().getNAME1L())
                + getOIVPM02I().getNAME1F();
    }

    public void setFILLER33(String source) {
        OIVPM02I.setNAME1L(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setNAME1F(source.substring(2));
    }

    public String getNAME1O() {
        return getOIVPM02I().getNAME1I();
    }

    public void setNAME1O(String source) {
        OIVPM02I.setNAME1I(source);
    }

    public String getFILLER34() {
        return String.valueOf(getOIVPM02I().getDEPT1L())
                + getOIVPM02I().getDEPT1F();
    }

    public void setFILLER34(String source) {
        OIVPM02I.setDEPT1L(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setDEPT1F(source.substring(2));
    }

    public String getDEPT1O() {
        return getOIVPM02I().getDEPT1I();
    }

    public void setDEPT1O(String source) {
        OIVPM02I.setDEPT1I(source);
    }

    public String getFILLER35() {
        return String.valueOf(getOIVPM02I().getPHON1L())
                + getOIVPM02I().getPHON1F();
    }

    public void setFILLER35(String source) {
        OIVPM02I.setPHON1L(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setPHON1F(source.substring(2));
    }

    public String getPHON1O() {
        return getOIVPM02I().getPHON1I();
    }

    public void setPHON1O(String source) {
        OIVPM02I.setPHON1I(source);
    }

    public String getFILLER36() {
        return String.valueOf(getOIVPM02I().getIDEN2L())
                + getOIVPM02I().getIDEN2F();
    }

    public void setFILLER36(String source) {
        OIVPM02I.setIDEN2L(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setIDEN2F(source.substring(2));
    }

    public String getIDEN2O() {
        return getOIVPM02I().getIDEN2I();
    }

    public void setIDEN2O(String source) {
        OIVPM02I.setIDEN2I(source);
    }

    public String getFILLER37() {
        return String.valueOf(getOIVPM02I().getNAME2L())
                + getOIVPM02I().getNAME2F();
    }

    public void setFILLER37(String source) {
        OIVPM02I.setNAME2L(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setNAME2F(source.substring(2));
    }

    public String getNAME2O() {
        return getOIVPM02I().getNAME2I();
    }

    public void setNAME2O(String source) {
        OIVPM02I.setNAME2I(source);
    }

    public String getFILLER38() {
        return String.valueOf(getOIVPM02I().getDEPT2L())
                + getOIVPM02I().getDEPT2F();
    }

    public void setFILLER38(String source) {
        OIVPM02I.setDEPT2L(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setDEPT2F(source.substring(2));
    }

    public String getDEPT2O() {
        return getOIVPM02I().getDEPT2I();
    }

    public void setDEPT2O(String source) {
        OIVPM02I.setDEPT2I(source);
    }

    public String getFILLER39() {
        return String.valueOf(getOIVPM02I().getPHON2L())
                + getOIVPM02I().getPHON2F();
    }

    public void setFILLER39(String source) {
        OIVPM02I.setPHON2L(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setPHON2F(source.substring(2));
    }

    public String getPHON2O() {
        return getOIVPM02I().getPHON2I();
    }

    public void setPHON2O(String source) {
        OIVPM02I.setPHON2I(source);
    }

    public String getFILLER40() {
        return String.valueOf(getOIVPM02I().getIDEN3L())
                + getOIVPM02I().getIDEN3F();
    }

    public void setFILLER40(String source) {
        OIVPM02I.setIDEN3L(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setIDEN3F(source.substring(2));
    }

    public String getIDEN3O() {
        return getOIVPM02I().getIDEN3I();
    }

    public void setIDEN3O(String source) {
        OIVPM02I.setIDEN3I(source);
    }

    public String getFILLER41() {
        return String.valueOf(getOIVPM02I().getNAME3L())
                + getOIVPM02I().getNAME3F();
    }

    public void setFILLER41(String source) {
        OIVPM02I.setNAME3L(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setNAME3F(source.substring(2));
    }

    public String getNAME3O() {
        return getOIVPM02I().getNAME3I();
    }

    public void setNAME3O(String source) {
        OIVPM02I.setNAME3I(source);
    }

    public String getFILLER42() {
        return String.valueOf(getOIVPM02I().getDEPT3L())
                + getOIVPM02I().getDEPT3F();
    }

    public void setFILLER42(String source) {
        OIVPM02I.setDEPT3L(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setDEPT3F(source.substring(2));
    }

    public String getDEPT3O() {
        return getOIVPM02I().getDEPT3I();
    }

    public void setDEPT3O(String source) {
        OIVPM02I.setDEPT3I(source);
    }

    public String getFILLER43() {
        return String.valueOf(getOIVPM02I().getPHON3L())
                + getOIVPM02I().getPHON3F();
    }

    public void setFILLER43(String source) {
        OIVPM02I.setPHON3L(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setPHON3F(source.substring(2));
    }

    public String getPHON3O() {
        return getOIVPM02I().getPHON3I();
    }

    public void setPHON3O(String source) {
        OIVPM02I.setPHON3I(source);
    }

    public String getFILLER44() {
        return String.valueOf(getOIVPM02I().getIDEN4L())
                + getOIVPM02I().getIDEN4F();
    }

    public void setFILLER44(String source) {
        OIVPM02I.setIDEN4L(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setIDEN4F(source.substring(2));
    }

    public String getIDEN4O() {
        return getOIVPM02I().getIDEN4I();
    }

    public void setIDEN4O(String source) {
        OIVPM02I.setIDEN4I(source);
    }

    public String getFILLER45() {
        return String.valueOf(getOIVPM02I().getNAME4L())
                + getOIVPM02I().getNAME4F();
    }

    public void setFILLER45(String source) {
        OIVPM02I.setNAME4L(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setNAME4F(source.substring(2));
    }

    public String getNAME4O() {
        return getOIVPM02I().getNAME4I();
    }

    public void setNAME4O(String source) {
        OIVPM02I.setNAME4I(source);
    }

    public String getFILLER46() {
        return String.valueOf(getOIVPM02I().getDEPT4L())
                + getOIVPM02I().getDEPT4F();
    }

    public void setFILLER46(String source) {
        OIVPM02I.setDEPT4L(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setDEPT4F(source.substring(2));
    }

    public String getDEPT4O() {
        return getOIVPM02I().getDEPT4I();
    }

    public void setDEPT4O(String source) {
        OIVPM02I.setDEPT4I(source);
    }

    public String getFILLER47() {
        return String.valueOf(getOIVPM02I().getPHON4L())
                + getOIVPM02I().getPHON4F();
    }

    public void setFILLER47(String source) {
        OIVPM02I.setPHON4L(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setPHON4F(source.substring(2));
    }

    public String getPHON4O() {
        return getOIVPM02I().getPHON4I();
    }

    public void setPHON4O(String source) {
        OIVPM02I.setPHON4I(source);
    }

    public String getFILLER48() {
        return String.valueOf(getOIVPM02I().getIDEN5L())
                + getOIVPM02I().getIDEN5F();
    }

    public void setFILLER48(String source) {
        OIVPM02I.setIDEN5L(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setIDEN5F(source.substring(2));
    }

    public String getIDEN5O() {
        return getOIVPM02I().getIDEN5I();
    }

    public void setIDEN5O(String source) {
        OIVPM02I.setIDEN5I(source);
    }

    public String getFILLER49() {
        return String.valueOf(getOIVPM02I().getNAME5L())
                + getOIVPM02I().getNAME5F();
    }

    public void setFILLER49(String source) {
        OIVPM02I.setNAME5L(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setNAME5F(source.substring(2));
    }

    public String getNAME5O() {
        return getOIVPM02I().getNAME5I();
    }

    public void setNAME5O(String source) {
        OIVPM02I.setNAME5I(source);
    }

    public String getFILLER50() {
        return String.valueOf(getOIVPM02I().getDEPT5L())
                + getOIVPM02I().getDEPT5F();
    }

    public void setFILLER50(String source) {
        OIVPM02I.setDEPT5L(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setDEPT5F(source.substring(2));
    }

    public String getDEPT5O() {
        return getOIVPM02I().getDEPT5I();
    }

    public void setDEPT5O(String source) {
        OIVPM02I.setDEPT5I(source);
    }

    public String getFILLER51() {
        return String.valueOf(getOIVPM02I().getPHON5L())
                + getOIVPM02I().getPHON5F();
    }

    public void setFILLER51(String source) {
        OIVPM02I.setPHON5L(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setPHON5F(source.substring(2));
    }

    public String getPHON5O() {
        return getOIVPM02I().getPHON5I();
    }

    public void setPHON5O(String source) {
        OIVPM02I.setPHON5I(source);
    }

    public String getFILLER52() {
        return String.valueOf(getOIVPM02I().getBIDXL())
                + getOIVPM02I().getBIDXF();
    }

    public void setFILLER52(String source) {
        OIVPM02I.setBIDXL(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setBIDXF(source.substring(2));
    }

    public String getBIDXO() {
        return getOIVPM02I().getBIDXI();
    }

    public void setBIDXO(String source) {
        OIVPM02I.setBIDXI(source);
    }

    public String getFILLER53() {
        return String.valueOf(getOIVPM02I().getFIDXL())
                + getOIVPM02I().getFIDXF();
    }

    public void setFILLER53(String source) {
        OIVPM02I.setFIDXL(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setFIDXF(source.substring(2));
    }

    public String getFIDXO() {
        return getOIVPM02I().getFIDXI();
    }

    public void setFIDXO(String source) {
        OIVPM02I.setFIDXI(source);
    }

    public String getFILLER54() {
        return String.valueOf(getOIVPM02I().getMSGL())
                + getOIVPM02I().getMSGF();
    }

    public void setFILLER54(String source) {
        OIVPM02I.setMSGL(Integer.parseInt(source.substring(0, 2)));
        OIVPM02I.setMSGF(source.substring(2));
    }

    public String getMSGO() {
        return getOIVPM02I().getMSGI();
    }

    public void setMSGO(String source) {
        OIVPM02I.setMSGI(source);
    }

    public @Getter String DEFINITIONS_OF_EIBAID_FIELD = StringUtils.repeat(' ',
            1);
    public @Getter String PROT_DARK_MDT = "(";
    public @Getter @Setter OIVPBROS_WS_DATE_TIME_AREA WS_DATE_TIME_AREA = new OIVPBROS_WS_DATE_TIME_AREA();
    public @Getter String WSWRITEQ = StringUtils.repeat(' ', 8);
    public @Getter String WSREADQ = StringUtils.repeat(' ', 8);
    public @Getter String FILE01 = "OIVPFILE";
    public @Getter @Setter int KEY01 = 0;
    public @Getter @Setter int LEN = 4;
    public @Getter @Setter int START_KEY = 0;
    public @Getter @Setter int TEMP_KEY = 0;
    public @Getter @Setter int DATALEN = 104;
    public @Getter @Setter OIVPBROS_PEOPLE_INFO PEOPLE_INFO = new OIVPBROS_PEOPLE_INFO();
    public @Getter String START_CODE = StringUtils.repeat(' ', 2);
    public @Getter String DFHCOMMAREA = StringUtils.repeat(' ', 1);
    private final static BiFunction<Long, String, String> intFormatWithSign = (
            value, format) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.applyPattern("+" + format + ";-" + format);
        return nf.format(value);
    };

    public void setWS_TRANS_ID(String source) {
        WS_TRANS_ID = StringUtils.truncate(StringUtils.rightPad(source, 4), 4);
    }

    public void setWS_MAPSET_NAME(String source) {
        WS_MAPSET_NAME = StringUtils.truncate(StringUtils.rightPad(source, 7),
                7);
    }

    public void setWS_MAP_NAME(String source) {
        WS_MAP_NAME = StringUtils.truncate(StringUtils.rightPad(source, 7), 7);
    }

    public String getStringWS_RESPONSE_CODE() {
        return intFormatWithSign.apply((long) WS_RESPONSE_CODE, "00000000");
    }

    public String getStringWS_RESPONSE_CODE2() {
        return intFormatWithSign.apply((long) WS_RESPONSE_CODE2, "00000000");
    }

    public void setWS_COMMUNICATION_AREA(String source) {
        WS_COMMUNICATION_AREA = StringUtils.truncate(
                StringUtils.rightPad(source, 1), 1);
    }

    public String getStringWS_FIRST_TIME_FLAG() {
        return intFormatWithSign.apply((long) WS_FIRST_TIME_FLAG, "0000");
    }

    public void setDEFINITIONS_OF_EIBAID_FIELD(String source) {
        DEFINITIONS_OF_EIBAID_FIELD = StringUtils.truncate(
                StringUtils.rightPad(source, 1), 1);
    }

    public void setPROT_DARK_MDT(String source) {
        PROT_DARK_MDT = StringUtils
                .truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setWSWRITEQ(String source) {
        WSWRITEQ = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public void setWSREADQ(String source) {
        WSREADQ = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public void setFILE01(String source) {
        FILE01 = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public String getStringKEY01() {
        return intFormatWithSign.apply((long) KEY01, "00000000");
    }

    public String getStringLEN() {
        return intFormatWithSign.apply((long) LEN, "0000");
    }

    public String getStringSTART_KEY() {
        return intFormatWithSign.apply((long) START_KEY, "00000000");
    }

    public String getStringTEMP_KEY() {
        return intFormatWithSign.apply((long) TEMP_KEY, "00000000");
    }

    public String getStringDATALEN() {
        return intFormatWithSign.apply((long) DATALEN, "0000");
    }

    public void setSTART_CODE(String source) {
        START_CODE = StringUtils.truncate(StringUtils.rightPad(source, 2), 2);
    }

    public void setDFHCOMMAREA(String source) {
        DFHCOMMAREA = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }
}
